"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFirebaseVersion = void 0;
var fs_1 = __importDefault(require("fs"));
exports.getFirebaseVersion = function (reporter) {
    var _a;
    var yarnLock = 'yarn.lock';
    var packageLock = 'package-lock.json';
    var hasPackagelock = fs_1.default.existsSync(packageLock);
    var hasYarnLock = fs_1.default.existsSync(yarnLock);
    if (hasYarnLock) {
        if (hasPackagelock) {
            reporter.warn("yarn.lock and package-lock.json have both been detected.\n      gatsby-plugin-firebase-messaging will use yarn.lock to get your firebase version number");
        }
        var yarnStr = fs_1.default.readFileSync('yarn.lock', 'utf8');
        var fullFbRe = /^firebase@.*\d+\.\d+\.\d+/m;
        var fbNumRe = /\d+\.\d+\.\d+/m;
        var match = yarnStr.match(fullFbRe);
        if ((match === null || match === void 0 ? void 0 : match.length) === 1) {
            var version = (_a = match[0].match(fbNumRe)) === null || _a === void 0 ? void 0 : _a[0];
            if (version)
                return version;
            throw new Error(errStr + ", but found this firebase entry in yarn.lock: " + match[0]);
        }
        throw new Error(errStr);
    }
    if (hasPackagelock) {
        var parsedJson = JSON.parse(fs_1.default.readFileSync(packageLock, 'utf8'));
        var version = parsedJson.dependencies.firebase.version;
        if (version)
            return version;
    }
    throw new Error(errStr);
};
var errStr = 'could not find a firebase version';
